#import "MTLPreferencesWindowController.h"
#import "NSObject(MTLControlItemEnabler).h"

static MTLPreferencesWindowController* sharedInstance = nil;

@implementation MTLPreferencesWindowController

#pragma mark -
#pragma mark class methods

+ (id) sharedPreference
{
    if(sharedInstance == nil)
    {
        [[self alloc] init];
    }
	
    return sharedInstance;
}

#pragma mark -
#pragma mark init methods

- (id)initWithWindow:(NSWindow *)window
{
    self = [super initWithWindow:window];
	
    if(self)
	{
        sharedInstance = self;
        
        selectedNumber = 0;
        
        // see http://d.hatena.ne.jp/RNatori/comment?date=20070913
        [self setWindowFrameAutosaveName:[self windowNibName]];
	}
    
    return self;
}

#pragma mark -
#pragma mark dealloc

- (void) dealloc
{    
	sharedInstance = nil;

    [super dealloc];
}

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action methods

- (IBAction) cancel:(id)sender
{
    [self close];
}

// Radioボタンとか

- (IBAction) selectAction:(id<MTLControlItemEnablerProtocol>)sender
{
    selectedNumber = [sender selectedTag];
}

- (NSInteger) stateOfSelectAction:(id<MTLControlItemEnablerProtocol>)anItem
{
    NSLog(@"stateOfSelectAction %@", anItem);

    if ( [anItem selectedTag] == selectedNumber )
        return NSOnState;
    else
        return NSOffState;
}

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

- (NSString *)windowNibName
{
    return NSStringFromClass([self class]);
}

#pragma mark -
#pragma mark Utility methods

- (BOOL)validateUserInterfaceItem:(NSObject<NSValidatedUserInterfaceItem>*)anItem
{
	return [self controlItemEnabler:anItem];
}

@end
