//
//  MTLRuntimeUtility.m
//  EnablerTest
//
//  Created by narita on 2013/01/15.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "MTLRuntimeUtility.h"


// selectorにプレフィックスを追加して返す
SEL prefixedSelector(SEL inSelector, NSString* inPrefix)
{
    NSString* theSelectorString = NSStringFromSelector(inSelector);
    NSString* thePrefixedString = [inPrefix stringByAppendingString:
                                   [theSelectorString stringByReplacingCharactersInRange:NSMakeRange(0,1)
                                                                              withString:[[theSelectorString substringToIndex:1]
                                                                                          uppercaseString]]];
    return NSSelectorFromString(thePrefixedString);
}

SEL setterSelectorFromName(NSString* inName)
{
    NSString* theResultString = [NSString stringWithFormat:@"set%@:",
                                 [inName stringByReplacingCharactersInRange:NSMakeRange(0,1)
                                                                 withString:[[inName substringToIndex:1]
                                                                             uppercaseString]]];
    
    return NSSelectorFromString(theResultString);
}



// todo:命名規則を検討する事
@implementation NSObject (MTLRuntimeUtility)

- (EPropertyAttribute) propertyExistsAtName:(NSString *)inName
{
    EPropertyAttribute theResult   = 0x0;
    
    if( [self respondsToSelector:NSSelectorFromString(inName)] )
    {
        theResult |= propertyAttributeIsReadable;
    }
    
    if( [self respondsToSelector:setterSelectorFromName(inName)] )
    {
        theResult |= propertyAttributeIsWriteable;
    }
    
    return theResult;
}

@end
