//
//  NSInvocation+MTLAddition.m
//  EnablerTest
//
//  Created by narita on 2013/01/19.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "NSInvocation(MTLAddition).h"

@implementation NSInvocation (MTLAddition)

- (id) objectWrappedReturnValue
{
    NSMethodSignature* theSignature = [self methodSignature];
    const char* theReturnType   = [theSignature methodReturnType];

    void* thePtr = malloc([theSignature methodReturnLength]);

    [self getReturnValue:thePtr];
        
    id theResult = nil;
    
    if( 0 == strcmp(theReturnType, @encode(id)) )
    {
        theResult = *(id*)thePtr;
    }
    else if( 0 == strcmp(theReturnType, @encode(Class)) )
    {
        theResult = *(Class*)thePtr;
    }
    else if( 0 == strcmp(theReturnType, @encode(char)) )
    {
        theResult = [NSNumber numberWithChar:*(char*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(unsigned char)) )
    {
        theResult = [NSNumber numberWithUnsignedChar:*(unsigned char*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(short)) )
    {
        theResult = [NSNumber numberWithShort:*(short*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(unsigned short)) )
    {
        theResult = [NSNumber numberWithUnsignedShort:*(unsigned short*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(int)) )
    {
        theResult = [NSNumber numberWithInt:*(int*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(unsigned int)) )
    {
        theResult = [NSNumber numberWithUnsignedInt:*(unsigned int*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(long)) )
    {
        theResult = [NSNumber numberWithLong:*(long*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(unsigned long)) )
    {
        theResult = [NSNumber numberWithUnsignedLong:*(unsigned long*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(long long)) )
    {
        theResult = [NSNumber numberWithLongLong:*(long long*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(unsigned long long)) )
    {
        theResult = [NSNumber numberWithUnsignedLongLong:*(unsigned long long*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(float)) )
    {
        theResult = [NSNumber numberWithFloat:*(float*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(double)) )
    {
        theResult = [NSNumber numberWithDouble:*(double*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(BOOL)) )
    {
        theResult = [NSNumber numberWithBool:*(BOOL*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(NSInteger)) )
    {
        theResult = [NSNumber numberWithInteger:*(NSInteger*)thePtr];
    }
    else if( 0 == strcmp(theReturnType, @encode(NSUInteger)) )
    {
        theResult = [NSNumber numberWithUnsignedInteger:*(NSUInteger*)thePtr];
    }
    else
    {
        theResult =  [NSValue valueWithBytes:thePtr
                                    objCType:theReturnType];
    }
    
    free(thePtr);
    
    return theResult;
}

@end
