//
//  CCAppDelegate.m
//  CurrencyConverter
//
//  Created by narita on 2013/01/24.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "CCAppDelegate.h"
#import "NSObject(MTLControlItemEnabler).h"

@implementation CCAppDelegate

@synthesize model;

- (void)applicationDidFinishLaunching:(NSNotification *)notification
{
    self.model = [[[CCModel alloc] init] autorelease];
}

- (void) dealloc
{
    self.model = nil;
    
    [super dealloc];
}

// ここで、各種メソッド名を算出して呼出しています。
- (BOOL)validateUserInterfaceItem:(NSObject<NSValidatedUserInterfaceItem>*)anItem
{
	return [self controlItemEnabler:anItem];
}


//========================================
// 計算実行ボタン

- (IBAction)convert:(id)sender
{
    NSLog(@"convert:(id)%@", sender);
}

- (BOOL) canConvert:(id)sender
{
    return YES;
}


//========================================
// リセットボタン

- (IBAction)reset:(id)sender
{
    self.model.sourceCurrencyAmount = 0;
    self.model.rate = 0;    
}

- (BOOL) canReset:(id)sender
{
    return (self.model.sourceCurrencyAmount == 0 && self.model.rate == 0) == NO;
}

- (NSString*) titleOfReset:(NSObject<NSValidatedUserInterfaceItem>*)anItem
{
    if( [self canReset:anItem] )
    {
        return @"reset";
    }
    else
    {
        return @"Don't reset";
    }
}

- (NSString*) labelOfReset:(NSObject<NSValidatedUserInterfaceItem>*)anItem
{
    return [self titleOfReset:anItem];
}


//========================================
// レート設定のラジオボタン、メニュー、ToolbarのPopupメニュー

- (IBAction)rateAction:(id)sender
{    
    NSInteger tag = [sender selectedTag];
    
    self.model.rate = tag;
}

- (NSInteger) stateOfRateAction:(id<NSValidatedUserInterfaceItem, MTLControlItemEnablerProtocol>)anItem
{
    NSInteger tag = [anItem selectedTag];

    if( self.model.rate == tag )
    {
        return NSOnState;
    }
    
    return NSOffState;
}

//========================================
//
// 失敗。TextEditだとキー入力毎にUpdateされて入力出来ない
//- (IBAction) sourceCurrencyAmount:(id)sender
//{
//    self.model.sourceCurrencyAmount = [sender doubleValue];
//}
//
//- (NSString*) stringValueOfSourceCurrencyAmount:(id)sender
//{    
//    return [NSString stringWithFormat:@"%f", self.model.sourceCurrencyAmount];
//}


//========================================
// 結果フィールド

- (IBAction) convertCurrency:(id)sender
{
    // ダミー
}

- (NSString*) stringValueOfConvertCurrency:(id)sender
{
    return [NSString stringWithFormat:@"%f", self.model.convertCurrency];
}



@end
